const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const subSpecialistService = require("./subSpecialist.service");
const redisClient = require('../../../../redisClient');

router.post("/create", authorize(), create);
router.get("/", authorize(), getAll);
router.get("/filter", authorize(), filter);
router.get("/option", authorize(), option);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.put("/enabled/:id", authorize(), enabled);
router.delete("/:id", authorize(), _delete);

module.exports = router;

function create(req, res, next) {
  subSpecialistService
    .create(req.body)
    .then((result) => res.json(result))
    .catch(next);
}

async function getAll(req, res, next) {
  try {
      // Membuat cacheKey
      const cacheKey = `sub-specialists`;

      // Mengecek apakah data sudah ada di Redis
      const cachedData = await redisClient.get(cacheKey);
      if (cachedData) {
          return res.json(JSON.parse(cachedData));
      }

      // Jika tidak ada, panggil subSpecialistService.getAll()
      const result = await subSpecialistService.getAll();

      // Simpan hasilnya ke Redis dengan expire time misalnya 60 detik
      await redisClient.setEx(cacheKey, 60, JSON.stringify(result));

      // Kembalikan response JSON dari hasil panggilan service
      return res.json(result);
  } catch (error) {
      return next(error);
  }
}

// function getAll(req, res, next) {
//   subSpecialistService
//     .getAll()
//     .then((result) => res.json(result))
//     .catch(next);
// }

function filter(req, res, next) {
  subSpecialistService
    .filter(req.query)
    .then((result) => res.json(result))
    .catch(next);
}

async function option(req, res, next) {
    try {
        // Membuat cacheKey
        const cacheKey = `sub-specialists-options`;

        // Mengecek apakah data sudah ada di Redis
        const cachedData = await redisClient.get(cacheKey);
        if (cachedData) {
            return res.json(JSON.parse(cachedData));
        }

        // Jika tidak ada, panggil subSpecialistService.option()
        const result = await subSpecialistService.option();

        // Simpan hasilnya ke Redis dengan expire time misalnya 60 detik
        await redisClient.setEx(cacheKey, 60, JSON.stringify(result));

        // Kembalikan response JSON dari hasil panggilan service
        return res.json(result);
    } catch (error) {
        return next(error);
    }
}

// function option(req, res, next) {
//   subSpecialistService
//     .option()
//     .then((result) => res.json(result))
//     .catch(next);
// }

function count(req, res, next) {
  subSpecialistService
    .count()
    .then((result) => res.json(result))
    .catch(next);
}

function update(req, res, next) {
  subSpecialistService
    .update(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function enabled(req, res, next) {
  subSpecialistService
    .enabled(req.params.id, req.body)
    .then((result) => res.json(result))
    .catch(next);
}

function _delete(req, res, next) {
  subSpecialistService
    .delete(req.params.id)
    .then((result) => res.json(result))
    .catch(next);
}
